unit TrnQf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, webtrans,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    BitBtn1: TBitBtn;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SimpleFileTransactionQueuer1: TSimpleFileTransactionQueuer;
    Status: TPanel;
    ICVerifyTransactionQueuer1: TICVerifyTransactionQueuer;
    Panel2: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    UseICVerify: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure UseICVerifyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Queuer: TCustomFileTransactionQueuer; // so we can switch queuing methods at run time

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   Edit1.text := ExtractFilePath(paramstr(0));
   Queuer := SimpleFileTransactionQueuer1;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  SimpleFileTransactionQueuer1.QueueDirectory := Edit1.text;
  ICVerifyTransactionQueuer1.QueueDirectory := Edit1.text;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin // same logic for Queue AND Check...
  with Queuer,Queuer.TransactionData do
  begin
    TransactionID := Edit5.Text; { name }
    Comment := 'Sample transaction';
    CardNumber:= Edit2.Text;
    ExpiryMonth:=Edit3.Text; { 01..12 }
    ExpiryYear:=Edit4.Text;  { 98, 99, 2000, 2001... }
    TransactionAmount :='20';
    QueueTransaction;
    Status.Caption := StatusMessage+' at '+DateTimeToStr(Age);
    if TransactionStatus in ([tsTimeOut, tsInvalid, tsCancel, tsAccept, tsReject]) then
       DeleteTransaction
    else { I guess it's queued }
      if not UseICVerify.checked then
        showmessage('Have a look in "'+Edit5.text+
          '.trn" for the details ');
  end;

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  with Queuer,Queuer.TransactionData do
  begin
    TransactionID := Edit5.Text; { name }
    CancelTransaction;
    Status.Caption := StatusMessage;
    if TransactionStatus in ([tsTimeOut, tsInvalid, tsCancel, tsAccept, tsReject]) then
      DeleteTransaction; // harmless if already done
  end;
end;

procedure TForm1.UseICVerifyClick(Sender: TObject);
begin
  if UseICVerify.checked then
     Queuer := ICVerifyTransactionQueuer1
  else
     Queuer := SimpleFileTransactionQueuer1
end;

end.
